/*
noprefix - removes lines starting with "prefix"

Copyright © 2014 C_Xperimental

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

Contact C_Xperimental via the website <www.cxperimental.weebly.com>

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *usage =
"noprefix \"prefix\" /path/inputfile /path/outputfile (must not exist)";

void
filefail (char *filename)
{
  printf ("%s could not be opened\n%s\n", filename, usage);
  exit (EXIT_FAILURE);
}

int
main (int argc, char *argv[])
{
  FILE *inputfile, *outputfile;
  char *string1;
  size_t nbytes = 10;
  ssize_t glval;

  if (argc != 4)
    {
      printf ("Supply prefix pattern and two filename arguments\n%s\n", usage);
      exit (EXIT_FAILURE);
    }
  inputfile = fopen (argv[2], "r");
  if (inputfile == NULL)
    {
      filefail (argv[1]);
    }
  outputfile = fopen (argv[3], "wx");
  if (outputfile == NULL)
    {
      filefail (argv[2]);
    }
  string1 = (char *) malloc (nbytes + 1);
  do
    {
      glval = getline (&string1, &nbytes, inputfile);
      if ((strncmp (string1, argv[1], (strlen (argv[1])))) && (glval != -1))
        {
          fprintf (outputfile, "%s", string1);
        }
    }
  while (glval != -1);
  return (EXIT_SUCCESS);
}
